//---------------------------------------------------------------------------

#ifndef DModUH
#define DModUH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ZConnection.hpp>
#include <ZDataset.hpp>
#include <ZSequence.hpp>

#include <memory>
//---------------------------------------------------------------------------
class TDM : public TDataModule
{
__published:	// IDE-managed Components
private:	// User declarations
public:		// User declarations
	std::auto_ptr<TZConnection> zConn;
	std::auto_ptr<TZQuery> qryData;
    std::auto_ptr<TZTable> tblData;

    typedef enum { ftAll = 0, ftByName, ftByPhone, ftByEmail, ftByWebsite,
        ftByAddress } TFilterType;

	__fastcall TDM(TComponent* Owner);

	TZQuery * __fastcall GetTreeData( TFilterType aFilterType, AnsiString aFilter );
    TZQuery * __fastcall GetPersonData( int aPID, AnsiString &aDesc );
    TZQuery * __fastcall GetCategories( );
    int  __fastcall AddGroup( AnsiString aGroupName );
    void __fastcall EditGroup( int aGID, AnsiString aGroupName );
    void __fastcall DelGroup( int aGID );
    int  __fastcall AddPerson( int aGID, AnsiString aName, AnsiString aDesc );
    void __fastcall EditPerson( int aPID, AnsiString aName, AnsiString aDesc,
        int aGID = -1 );
    void __fastcall DelPerson( int aPID );
    int  __fastcall AddContact( int aPID, int aCCID, int aCTID, AnsiString aContact );
    void __fastcall DelContact( int aCID );
};
//---------------------------------------------------------------------------
extern PACKAGE TDM *DM;
//---------------------------------------------------------------------------
#endif
