//---------------------------------------------------------------------------

#ifndef MainUH
#define MainUH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <Buttons.hpp>
#include <About.hpp>

#include <memory>

#include "DModU.h"
//---------------------------------------------------------------------------
class TMainController : public TObject
{
private:
	void __fastcall FilterTree( TDM::TFilterType aFilterType );
	void __fastcall AddGroup(   TTreeNode * aNode, AnsiString S );
    void __fastcall AddPerson(  TTreeNode * aNode, AnsiString S );

public:
	void __fastcall CmdRefreshTree( );
	void __fastcall CmdRefreshPerson( );
    void __fastcall CmdClearPerson( );
	void __fastcall CmdAddGroup( );
	void __fastcall CmdEditGroup( );
	void __fastcall CmdEditedGroup(  TTreeNode * aNode, AnsiString S );
	void __fastcall CmdDelGroup( );
	void __fastcall CmdAddPerson( );
	void __fastcall CmdEditPerson( );
    void __fastcall CmdEditedPerson( TTreeNode * aNode, AnsiString S, AnsiString aDesc );
    void __fastcall CmdEditPersonDesc( );
    void __fastcall CmdEditPersonGrp( TTreeNode * aNewGroup );
	void __fastcall CmdDelPerson( );
	void __fastcall CmdAddContact( );
	void __fastcall CmdDelContact( );
};
//---------------------------------------------------------------------------

class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TCoolBar *CoolBar1;
	TToolBar *ToolBar1;
	TStatusBar *StatusBar1;
	TPanel *Panel1;
	TToolButton *ToolButton1;
	TToolButton *ToolButton2;
	TMainMenu *MainMenu1;
	TMenuItem *miSystem;
	TPanel *Panel2;
	TTreeView *tvPerson;
	TSplitter *Splitter1;
	TPanel *Panel4;
	TListView *lvContact;
	TPanel *Panel5;
	TSplitter *Splitter2;
	TActionList *alMain;
	TImageList *ilMain;
	TAction *actAddGroup;
	TAction *actEditGroup;
	TAction *actDelGroup;
	TAction *actAddPerson;
	TAction *actEditPerson;
	TAction *actDelPerson;
	TAction *actAddContact;
	TAction *actDelContact;
	TMenuItem *miExit;
	TMenuItem *miGroup;
	TMenuItem *miAddGroup;
	TMenuItem *miEditGroup;
	TMenuItem *miDelGroup;
	TMenuItem *miPerson;
	TMenuItem *miPersonAdd;
	TMenuItem *miPersionEdit;
	TMenuItem *miPersonDel;
	TMenuItem *miContact;
	TMenuItem *miContactAdd;
	TMenuItem *miContactDel;
	TToolButton *ToolButton3;
	TToolButton *ToolButton4;
	TToolButton *ToolButton5;
	TToolButton *ToolButton6;
	TToolButton *ToolButton7;
	TToolButton *ToolButton8;
	TToolButton *ToolButton9;
	TToolButton *ToolButton10;
	TAction *actRefresh;
	TMenuItem *miRefresh;
	TMenuItem *miSystemSep;
	TMemo *memoPersonDesc;
	TMenuItem *miHelp;
	TMenuItem *miHelpAbout;
	TBitBtn *btnRefresh;
	TPopupMenu *pmTree;
	TMenuItem *pmiAdd;
	TMenuItem *pmiEdit;
	TMenuItem *pmiDel;
	TComboBox *cbFilterType;
	TEdit *editFilter;
    TMenuItem *pmiSpliter;
	void __fastcall actRefreshExecute(TObject *Sender);
	void __fastcall actAddGroupExecute(TObject *Sender);
	void __fastcall actEditGroupExecute(TObject *Sender);
	void __fastcall actDelGroupExecute(TObject *Sender);
	void __fastcall pmTreePopup(TObject *Sender);
	void __fastcall actAddPersonExecute(TObject *Sender);
	void __fastcall actEditPersonExecute(TObject *Sender);
	void __fastcall actDelPersonExecute(TObject *Sender);
	void __fastcall actAddContactExecute(TObject *Sender);
	void __fastcall actDelContactExecute(TObject *Sender);
	void __fastcall miExitClick(TObject *Sender);
	void __fastcall miHelpAboutClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall tvPersonEdited(TObject *Sender, TTreeNode *Node,
          AnsiString &S);
	void __fastcall tvPersonChange(TObject *Sender, TTreeNode *Node);
    void __fastcall memoPersonDescExit(TObject *Sender);
    void __fastcall lvContactDblClick(TObject *Sender);
    void __fastcall tvPersonChanging(TObject *Sender, TTreeNode *Node,
          bool &AllowChange);
    void __fastcall tvPersonMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall tvPersonDragOver(TObject *Sender, TObject *Source, int X,
          int Y, TDragState State, bool &Accept);
    void __fastcall tvPersonDragDrop(TObject *Sender, TObject *Source, int X,
          int Y);
    void __fastcall tvPersonMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
    void __fastcall tvPersonMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// User declarations
    std::auto_ptr<TMainController> FCtrl;
    std::auto_ptr<TAboutDialog> FAbout;
    TPoint FPoint;

    TMainController * getController( ) { return FCtrl.get(); }
public:		// User declarations
	__fastcall TMainForm(TComponent* Owner);

    //  for controller test purpose
    __property TMainController * Controller = { read = getController };
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
